import os
from setuptools import setup


def readme():
    with open('README.md') as f:
        return f.read()


if __name__ == "__main__":
      setup(name='floot_converter_gui',
            version='0.2.0',
            description='Fancy GUI for Fluka to Root Converter',
            long_description=readme(),
            classifiers=[
              'Development Status :: 3 - Alpha',
              'License :: OSI Approved :: BSD License',
              'Programming Language :: Python :: 2.7',
		      'Programming Language :: Python :: 2.6',
              'Topic :: Scientific/Engineering :: Physics',
            ],
            keywords='fluka root converter gui physics',
            url='https://github.com/PatrykPasterny/PITE_Project',
            author='Patryk Pasterny',
            author_email='4romanowski@fis.agh.edu.pl',
            license='BSD',
            packages=[
              'fluka_gui',
              'fluka_gui.sf2rconverter',
              'fluka_gui.Test',
              'fluka_gui.Test.Data',
              'fluka_gui.info',
            ],
            install_requires=[
              'matplotlib',
            ],
            include_package_data=True,
            zip_safe=False)

